﻿package 
{
	import flash.display.Bitmap;
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	/**
	 * 書き出し画像対象用データ管理
	 * @author KazutakaSAKURAI
	 */
	public class SetLayer
	{
		private var drawBase:MovieClip;
		private var _libBtn:SimpleButton;
		private var _drawLineBtn:SimpleButton;
		private var _resetBtn:SimpleButton;
		private var cntLayer:int = 1;
		private const BASE_W:Number = 320;
		private const BASE_H:Number = 320;
		
		public function SetLayer(mc:MovieClip) {
			drawBase = mc;
		}
		public function setBtn(libBtn:SimpleButton,dLineBtn:SimpleButton,resetBtn:SimpleButton) {
			_libBtn = libBtn;
			_libBtn.addEventListener(MouseEvent.CLICK, setMcAnime );
			_drawLineBtn = dLineBtn;
			_drawLineBtn.addEventListener(MouseEvent.CLICK, setDrawLine );
			_resetBtn = resetBtn;
			_resetBtn.addEventListener( MouseEvent.CLICK, resetBase );
		}
		/**
		 * Layer名取得
		 * @return
		 */
		private function getLayerName():String{
			var layerName:String = "layer" + cntLayer;
			cntLayer++;
			return layerName;
		}
		/**
		 * ビットマップセット
		 * @param ローカル画像
		 * @see LocalFileLoad.initLoaded();
		 */
		public function setBmp(local_bmp:Bitmap) {
			var layer_sp:Sprite = new Sprite();
			layer_sp.name = getLayerName();
			layer_sp.addChild( local_bmp );
			drawBase.addChild( layer_sp );			
		}
		/**
		 * ライブラリのアニメーション
		 */
		public function setMcAnime(evt:MouseEvent=null) {
			var hito_mc:MovieClip = new hitoMc();
			hito_mc.name = getLayerName();
			hito_mc.x = BASE_W / 2+ Math.random()*200-100;
			hito_mc.y = BASE_H/ 2+ Math.random()*200-100;
			drawBase.addChild( hito_mc )
		}
		/**
		 * お絵かきセット
		 * @param	evt
		 */
		private function setDrawLine(evt:MouseEvent=null) {
			var dTool:DrawTool = new DrawTool();
			dTool.drawModeInit( 0, 0, BASE_W, BASE_H
											,0xE32700, 2);
			dTool.name = getLayerName();
			drawBase.addChild( dTool );
		}
		/**
		 * 画像消去
		 */
		private function resetBase(evt:MouseEvent=null) {
			while ( drawBase.numChildren > 0) {
				drawBase.removeChildAt(0);
			}
		}		
	}
	
}